﻿<?php // adduser.php

  // Le code PHP (les fonctions PHP viennent en fin de script)

  $forename = $surname = $username = $password = $age = $email = "";

  if (isset($_POST['forename']))
    $forename = fix_string($_POST['forename']);
  if (isset($_POST['surname']))
    $surname  = fix_string($_POST['surname']);
  if (isset($_POST['username']))
    $username = fix_string($_POST['username']);
  if (isset($_POST['password']))
    $password = fix_string($_POST['password']);
  if (isset($_POST['age']))
    $age      = fix_string($_POST['age']);
  if (isset($_POST['email']))
    $email    = fix_string($_POST['email']);

  $fail  = validate_forename($forename);
  $fail .= validate_surname($surname);
  $fail .= validate_username($username);
  $fail .= validate_password($password);
  $fail .= validate_age($age);
  $fail .= validate_email($email);

  echo "<!DOCTYPE html>\n<html><head><title>Exemple de formulaire</title>";

  if ($fail == "")
  {
    echo "</head><body>Données du formulaire validées avec succès :
      $forename, $surname, $username, $password, $age, $email.</body></html>";

    // Ici vient s'insérer le code nécessaire pour enregistrer les champs
    // du formulaire dans une base de données, de préférence à l'aide
    // de la fonction de chiffrement password_hash dans le cas du mot de passe.

    exit;
  }

  echo <<<_END

    <!-- La section HTML/JavaScript -->

    <style>
      .signup {
        border: 1px solid #999999;
      font:   normal 14px helvetica; color:#444444;
      }
    </style>

    <script>
      function validate(form)
      {
        fail  = validateForename(form.forename.value)
        fail += validateSurname(form.surname.value)
        fail += validateUsername(form.username.value)
        fail += validatePassword(form.password.value)
        fail += validateAge(form.age.value)
        fail += validateEmail(form.email.value)
      
        if (fail == "")     return true
        else { alert(fail); return false }
      }

      function validateForename(field)
      {
        return (field == "") ? "Aucun prénom entré.\n" : ""
      }

      function validateSurname(field)
      {
        return (field == "") ? "Aucun nom de famille entré.\n" : ""
      }

      function validateUsername(field)
      {
        if (field == "") return "Aucun nom d'utilisateur entré.\n"
        else if (field.length < 5)
          return "Le nom d'utilisateur doit contenir au moins 5 caractères.\n"
        else if (/[^a-zA-Z0-9_-]/.test(field))
          return "Seuls caractères permis dans le nom d'utilisateur : " +
                 "a-z, A-Z, 0-9, - et _.\n"
        return ""
      }

      function validatePassword(field)
      {
        if (field == "") return "Aucun mot de passe entré.\n"
        else if (field.length < 6)
          return "Le mot de passe doit contenir au moins 6 caractères.\n"
        else if (! /[a-z]/.test(field) ||
                 ! /[A-Z]/.test(field) ||
                 ! /[0-9]/.test(field))
          return "Le mot de passe doit contenir au moins un a-z, A-Z et 0-9.\n"
        return ""
      }

      function validateAge(field)
      {
        if (field == "" || isNaN(field)) return "Entrez l'âge en chiffres.\n"
        else if (field < 18 || field > 110)
          return "L'âge doit être compris entre 18 et 110.\n"
        return ""
      }

      function validateEmail(field)
      {
        if (field == "") return "Entrez une adresse de courrier électronique.\n"
          else if (!((field.indexOf(".") > 0) &&
                     (field.indexOf("@") > 0)) ||
                     /[^a-zA-Z0-9.@_-]/.test(field))
            return "L'adresse de courrier électronique n'est pas valable.\n"
        return ""
      }
    </script>
  </head>
  <body>

    <table border="0" cellpadding="2" cellspacing="5" 
      bgcolor="#eeeeee">
      <th colspan="2" align="center">Formulaire d'inscription</th>

        <tr><td colspan="2">Désolé, mais votre formulaire<br>
          comporte les erreurs suivantes : 
          <p><font color=red size=1><i>$fail</i></font></p>
        </td></tr>

      <form method="post" action="adduser.php" onSubmit="return validate(this)">
        <tr><td>Prénom</td>
          <td><input type="text" maxlength="32" name="forename" value="$forename">
        </td></tr><tr><td>Nom</td>
          <td><input type="text" maxlength="32" name="surname"  value="$surname">
        </td></tr><tr><td>Nom d'utilisateur</td>
          <td><input type="text" maxlength="16" name="username" value="$username">
        </td></tr><tr><td>Mot de passe</td>
          <td><input type="text" maxlength="12" name="password" value="$password">
        </td></tr><tr><td>Âge</td>
          <td><input type="text" maxlength="3"  name="age"      value="$age">
        </td></tr><tr><td>Courriel</td>
          <td><input type="text" maxlength="64" name="email"    value="$email">
        </td></tr><tr><td colspan="2" align="center"><input type="submit"
          value="Inscription"></td></tr>
      </form>
    </table>
  </body>
</html>

_END;

  // Les fonctions en PHP

  function validate_forename($field)
  {
  	return ($field == "") ? "Aucun prénom entré.<br>": "";
  }
  
  function validate_surname($field)
  {
  	return($field == "") ? "Aucun nom de famille entré.<br>" : "";
  }
  
  function validate_username($field)
  {
    if ($field == "") return "Aucun nom d'utilisateur entré.<br>";
    else if (strlen($field) < 5)
      return "Le nom d'utilisateur doit contenir au moins 5 caractères.<br>";
    else if (preg_match("/[^a-zA-Z0-9_-]/", $field))
      return "Seuls caractères permis dans le nom d'utilisateur : " .
                 "a-z, A-Z, 0-9, - et _.<br>";
    return "";		
  }
  
  function validate_password($field)
  {
    if ($field == "") return "Aucun mot de passe entré.<br>";
    else if (strlen($field) < 6)
      return "Le mot de passe doit contenir au moins 6 caractères.<br>";
    else if (!preg_match("/[a-z]/", $field) ||
             !preg_match("/[A-Z]/", $field) ||
             !preg_match("/[0-9]/", $field))
      return "Le mot de passe doit contenir au moins un a-z, A-Z et 0-9.<br>";
    return "";
  }
  
  function validate_age($field)
  {
    if ($field == "") return "Aucun âge entré.<br>";
    else if ($field < 18 || $field > 110)
      return "L'âge doit être compris entre 18 et 110.<br>";
    return "";
  }
  
  function validate_email($field)
  {
    if ($field == "") return "Entrez une adresse de courrier électronique.<br>";
      else if (!((strpos($field, ".") > 0) &&
                 (strpos($field, "@") > 0)) ||
                  preg_match("/[^a-zA-Z0-9.@_-]/", $field))
        return "L'adresse de courrier électronique n'est pas valable.<br>";
    return "";
  }
  
  // Aseptisation
  function fix_string($string)
  {
    if (get_magic_quotes_gpc()) $string = stripslashes($string);
    return htmlentities ($string);
  }
?>
